
#include <Adafruit_NeoPixel.h>
#define LED_PIN     6
#define LED_COUNT  24
#define BRIGHTNESS 50
Adafruit_NeoPixel strip(LED_COUNT, LED_PIN, NEO_GRB + NEO_KHZ800);

const int BUZZER = 10;

#define LEDPIN 13
// Pin 13: Arduino has an LED connected on pin 13
// Pin 11: Teensy 2.0 has the LED on pin 11
// Pin  6: Teensy++ 2.0 has the LED on pin 6
// Pin 13: Teensy 3.0 has the LED on pin 13

#define SENSORPIN 4

// variables will change:
int sensorState = 0, lastState = 0;       // variable for reading the pushbutton status

void setup() {
  // initialize the LED pin as an output:
  pinMode(LEDPIN, OUTPUT);
  // initialize the sensor pin as an input:
  pinMode(SENSORPIN, INPUT);
  digitalWrite(SENSORPIN, HIGH); // turn on the pullup
  strip.begin();           // INITIALIZE NeoPixel strip object (REQUIRED)
  strip.show();            // Turn OFF all pixels ASAP
  strip.setBrightness(50); // Set BRIGHTNESS to about 1/5 (max = 255)
  Serial.begin(9600);
  pinMode(BUZZER,OUTPUT);
}

bool broken = false;
long timeBefore;
long timeNow;
int delayTime;

void loop() {
  // read the state of the pushbutton value:
  sensorState = digitalRead(SENSORPIN);

  // check if the sensor beam is broken
  // if it is, the sensorState is LOW:
  Serial.println(sensorState);
  if (broken == true){
    timeNow = millis();
    delayTime = (timeNow - timeBefore)/2000;
    delayTime = abs((20 - delayTime ) % 20);
    Serial.println(delayTime);
    pulseRed(delayTime); 
    digitalWrite(BUZZER, HIGH);
    delay(5);
    digitalWrite(BUZZER, LOW);
  }

  if (sensorState && !lastState) {
    Serial.println("Unbroken");
    strip.fill(strip.Color(0, 0, 0));
    broken = false;
    timeBefore = millis();
    
    
  }
  if (!sensorState && lastState) {
    Serial.println("Broken");
    broken = true;
  }
  lastState = sensorState;

}




void pulseRed(uint8_t wait) {
  for (int j = 0; j < 256; j+=2) { // Ramp up from 0 to 255
    // Fill entire strip with white at gamma-corrected brightness level 'j':
    strip.fill(strip.Color(j, 0, 0));
    strip.show();
    delay(wait);
  }
}
